/************************************************************************/
/*                           Meshscale                                  */
/*   (C) Copyright 2000 Randy Sybel (aka Shadowspawn)                   */
/*            All Rights Reserved.                                      */
/*       You are allowed to use this program in any way you see fit.    */
/*       However, please retain the copyright information               */
/*                                                                      */
/************************************************************************/

#include    <stdlib.h>
#include    <stdio.h>
#include    <string.h>


int main    ( int argc, char *argv[] )
{
char        buf[256], OutName[128];
char        *tp;
double      ScaleX, ScaleY, ScaleZ, arg1, arg2, arg3;
int         fout, InPoints, InParts;

FILE        *ofp, *ifp;



ifp = ofp = NULL;

printf ( "Meshscale Version 2.0 by Shadowspawn\n" );

if ( ( argc != 5 ) &&
     ( argc != 6 ) ) {
  printf ( "Usage: meshscale xScale yScale zScale Infile [Outfile]\n");
  exit ( 1 );
  }

if ( argc == 6 ) {
  strcpy ( OutName, argv[5] );
  }
else {
  strcpy ( OutName, argv[4] );
  strcat ( OutName, "s" );
  }

if ( strcmp ( argv[4], OutName ) == 0 ) {
  printf ( "Input file and Output file cannot be the same! %s\n", argv[5] );
  exit ( 1 );
  }

ScaleX  = atof ( argv[1] );
ScaleY  = atof ( argv[2] );
ScaleZ  = atof ( argv[3] );


ifp = fopen ( argv[4], "r" );
if ( ifp == NULL ) {
  printf ( "Can't open input file %s\n", argv[4] );
  exit ( 1 );
  }

ofp = fopen ( OutName, "w+t" );
if ( ofp == NULL ) {
  printf ( "Can't open output file %s\n", OutName );
  exit ( 1 );
  }

InPoints = 0;
InParts = 0;
tp = (char *) 1;
while ( tp ) {
  tp = fgets ( buf, sizeof(buf), ifp );

  if ( tp == NULL )             // EOF check
    continue;

//  POINTS scaling

  if ( InPoints ) {
    fout = sscanf ( buf, "%lg,%lg,%lg", &arg1, &arg2, &arg3 );
    if ( fout != 3 ) {
        if ( strcmp ( buf, "}\n" ) == 0 ) {
            InPoints = 0;
            }
        else {
            fclose ( ifp );
            fclose ( ofp );
            printf ( "Unable to read point array: (%s)\n", buf );
            exit ( 1 );
            }
        }
    if ( InPoints ) {
        arg1 *= ScaleX;
        arg2 *= ScaleY;
        arg3 *= ScaleZ;
        sprintf ( buf, "%.6f,%.6f,%.6f;\n", arg1, arg2, arg3 );
        }
    }
  if ( strcmp ( buf, "POINTS{\n" ) == 0 ) {
    InPoints = 1;
    }

//  Output the data, modified or not

  fout = fputs ( buf, ofp );
  }

if ( ifp )
  fclose ( ifp );

if ( ofp )
  fclose ( ofp );

return ( 0 );
}
